/*
    Copyright 2009 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl-2.0.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "show_dump.h"

typedef unsigned char   u8;



#define VER     "0.1"



void std_err(void);



int main(int argc, char *argv[]) {
typedef struct {
    u8      data1[2];
    u8      data2[0x12];
    u8      data3[0x200];
} pck_t;

    static const u8
            boh2[] = "\x80\xE5\x0E\x38\xBA\x63\x4C\x99\x88\x63\x4C\xD6\x54\xB8\x65\x7E\xBF\x8A\xF0\x17\x8A\xAA\x4D\x0F\xB7\x23\x27\xF6\xEB\x12\xF8\xEA\x17\xB7\xCF\x52\x57\xCB\x51\xCF\x1B\x14\xFD\x6F\x84\x38\xB5\x24\x11\xCF\x7A\x75\x7A\xBB\x78\x74\xDC\xBC\x42\xF0\x17\x3F\x5E\xEB\x74\x77\x04\x4E\x8C\xAF\x23\xDC\x65\xDF\xA5\x65\xDD\x7D\xF4\x3C\x4C\x95\xBD\xEB\x65\x1C\xF4\x24\x5D\x82\x18\xFB\x50\x86\xB8\x53\xE0\x4E\x36\x96\x1F\xB7\xCB\xAA\xAF\xEA\xCB\x20\x27\x30\x2A\xAE\xB9\x07\x40\xDF\x12\x75\xC9\x09\x82\x9C\x30\x80\x5D\x8F\x0D\x09\xA1\x64\xEC\x91\xD8\x8A\x50\x1F\x40\x5D\xF7\x08\x2A\xF8\x60\x62\xA0\x4A\x8B\xBA\x4A\x6D\x00\x0A\x93\x32\x12\xE5\x07\x01\x65\xF5\xFF\xE0\xAE\xA7\x81\xD1\xBA\x25\x62\x61\xB2\x85\xAD\x7E\x9D\x3F\x49\x89\x26\xE5\xD5\xAC\x9F\x0E\xD7\x6E\x47\x94\x16\x84\xC8\xFF\x44\xEA\x04\x40\xE0\x33\x11\xA3\x5B\x1E\x82\xFF\x7A\x69\xE9\x2F\xFB\xEA\x9A\xC6\x7B\xDB\xB1\xFF\x97\x76\x56\xF3\x52\xC2\x3F\x0F\xB6\xAC\x77\xC4\xBF\x59\x5E\x80\x74\xBB\xF2\xDE\x57\x62\x4C\x1A\xFF\x95\x6D\xC7\x04\xA2\x3B\xC4\x1B\x72\xC7\x6C\x82\x60\xD1\x0D",
            boh3[] = "\x82\x8B\x7F\x68\x90\xE0\x44\x09\x19\x3B\x8E\x5F\xC2\x82\x38\x23\x6D\xDB\x62\x49\x52\x6E\x21\xDF\x51\x6C\x76\x37\x86\x50\x7D\x48\x1F\x65\xE7\x52\x6A\x88\xAA\xC1\x32\x2F\xF7\x54\x4C\xAA\x6D\x7E\x6D\xA9\x8C\x0D\x3F\xFF\x6C\x09\xB3\xA5\xAF\xDF\x98\x02\xB4\xBE\x6D\x69\x0D\x42\x73\xE4\x34\x50\x07\x30\x79\x41\x2F\x08\x3F\x42\x73\xA7\x68\xFA\xEE\x88\x0E\x6E\xA4\x70\x74\x22\x16\xAE\x3C\x81\x14\xA1\xDA\x7F\xD3\x7C\x48\x7D\x3F\x46\xFB\x6D\x92\x25\x17\x36\x26\xDB\xDF\x5A\x87\x91\x6F\xD6\xCD\xD4\xAD\x4A\x29\xDD\x7D\x59\xBD\x15\x34\x53\xB1\xD8\x50\x11\x83\x79\x66\x21\x9E\x87\x5B\x24\x2F\x4F\xD7\x73\x34\xA2\xF7\x09\xD5\xD9\x42\x9D\xF8\x15\xDF\x0E\x10\xCC\x05\x04\x35\x81\xB2\xD5\x7A\xD2\xA0\xA5\x7B\xB8\x75\xD2\x35\x0B\x39\x8F\x1B\x44\x0E\xCE\x66\x87\x1B\x64\xAC\xE1\xCA\x67\xB4\xCE\x33\xDB\x89\xFE\xD8\x8E\xCD\x58\x92\x41\x50\x40\xCB\x08\xE1\x15\xEE\xF4\x64\xFE\x1C\xEE\x25\xE7\x21\xE6\x6C\xC6\xA6\x2E\x52\x23\xA7\x20\xD2\xD7\x28\x07\x23\x14\x24\x3D\x45\xA5\xC7\x90\xDB\x77\xDD\xEA\x38\x59\x89\x32\xBC\x00\x3A\x6D\x61\x4E\xDB\x29";
    pck_t   pck;
    FILE    *fd;
    int     i,
            len,
            tmp;

    fputs("\n"
        "Ventrilo port 5000 packet decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <packet_file>\n"
            "\n", argv[0]);
        exit(1);
    }

    fd = fopen(argv[1], "rb");
    if(!fd) std_err();
    len = fread(&pck, 1, sizeof(pck), fd);
    fclose(fd);

    len -= (sizeof(pck.data1) + sizeof(pck.data2));

    tmp = pck.data1[0];
    for(i = 0; i < 0x12; i++) {
        pck.data2[i] -= (boh2[tmp & 0xff] + (i % 5));
        tmp += pck.data1[1];
    }

    tmp = pck.data2[0xe];
    for(i = 0; i < len; i++) {
        pck.data3[i] -= (boh3[tmp & 0xff] + (i % 0x48));
        tmp += pck.data2[0xf];
    }

    printf("- dump of the header bytes (%d + %d):\n\n", sizeof(pck.data1), sizeof(pck.data2));
    show_dump((void *)&pck, sizeof(pck.data1) + sizeof(pck.data2), stdout);

    if(len > 0) {
        printf("\n- dump only the last data bytes (%d):\n\n", len);
        show_dump(pck.data3, len, stdout);
    }
    return(0);
}



void std_err(void) {
    perror("\nError");
    exit(1);
}

